clear all

warning off;
cmats = zeros(126,10,10)/0;
cmat3 = zeros(1260,9)/0;
cmat3_2gp = zeros(1260,1)/0;
indexmat = zeros(5,5)/0;
warning on;


% CREATE cmats
thismat = 0;
for na =  2:5
for nb = na:5
    thismat  = thismat+1
    indexmat(na,nb) = thismat;
    indexmat(nb,na) = thismat;
    numtotal = na+nb;

    count = 0;
    for j=1:(2^numtotal-1)
        p1 = bitget(j,numtotal:-1:1)';
        if (sum(p1)==na)
            pos1 = (find(p1))';
            pos2 = (find(1-p1))';
            if ~(na==nb && pos1(1)~=1) && ~isequal(pos1,[1:na])
                count = count+1;
                cmats(count,1:numtotal,thismat) = [pos1 pos2];
            end
        end
    end
    if count ~= nchoosek(na+nb,na)/(1+(na==nb)) -1
        error('Something wrong here.')
    end
    
end
end

%CHECK validity of cmats: each row sorted is what it should be, and no
%two rows are equal.
for j=1:thismat
    cmats(:,:,j) = sortrows(cmats(:,:,j));
    thiscmat = cmats(:,:,j);
    rows=sum(~isnan(thiscmat(:,1)));
    cols=sum(~isnan(thiscmat(1,:)));
    relvcmat = thiscmat(1:rows,1:cols);
    for k=1:rows
        thisrow = relvcmat(k,:);
        if ~isequal(sort(thisrow),[1:cols])
            error('Something wrong here.')
        end
        if k<rows && isequal(thisrow,relvcmat(k+1,:))
            error('Something wrong here.')
        end
    end
end


na=2;
nb=3;
nc=4;

numtotal = na+nb+nc;
numresid = na+nb;

count = 0;
for j=1:(2^numtotal-1)
    p3 = bitget(j,numtotal:-1:1)';
    if (sum(p3)==nc)
        pos3 = (find(p3))';
        poso = (find(1-p3))';
        for k=1:(2^numresid-1)
            p2 = bitget(k,numresid:-1:1)';
            if (sum(p2)==nb)
                pos2 = poso(find(p2));
                pos1 = poso(find(1-p2));
                if (~isequal(pos1,[1:na]) || ~isequal(pos2,[na+1:na+nb]))
                    count = count+1;
                    cmat3(count,:) = [pos1 pos2 pos3];
                end
            end
        end
    end
end

if count ~= nchoosek(na+nb+nc,na+nb)*nchoosek(na+nb,na) -1
    error('Something wrong here.')
end
cmat3 = sortrows(cmat3);
for k=1:count
    thisrow = cmat3(k,:);
    if ~isequal(sort(thisrow),[1:9])
        error('Something wrong here.')
    end
    if k<rows && isequal(thisrow,cmat3(k+1,:))
        error('Something wrong here.')
    end
end

for j=1:count
    cmat3_2gp(j) = min(cmat3(j,1:2)==[1 2]) + min(cmat3(j,3:5) == [3:5]) + min(cmat3(j,6:9)==[6:9]);
end

save ..\MultivariateTables2-3\data\combmats cmats cmat3 cmat3_2gp indexmat;