clear all
data = xlsread('resurveymain','b2:bt391');
[rows,cols]=size(data);
savedfilepath = '..\UnivariateFigs1-6\data\resurvey';

mainvars = char('worstyear', 'income', 'expincome', 'prob', 'coeffvar');
mainvarsshort = char('wst', 'inc', 'exp', 'prob', 'coef');
mainvarcols = [3 9 11 15 17]';
[nummainvars junk] = size(mainvars);

expsuffs = char('farming','shrimpfish','business');
expvars  = strcat('exp_',expsuffs);
expvarcols = [19:21]';
revsuffs = char('A','B','C','D','E','F','G','H','I','J','K','L','M',...
    'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',...
    'AA','BB','CC','DD','EE','FF','GG','HH','II','II1','II2','II3');
revvars  = strcat('rev_',revsuffs);
revvarcols = [22:59]';
occvars  = char(expvars, revvars);
[numoccvars junk] = size(occvars);
occvarcols = [expvarcols; revvarcols];

village     = data(:,1);
hhid        = data(:,2);

for k=1:nummainvars
    command = [deblank(mainvars(k,:)) ' = data(:,' num2str(mainvarcols(k)) ');'];
    eval(command);
end
for k=1:numoccvars
    command = [deblank(occvars(k,:)) ' = data(:,' num2str(occvarcols(k)) ');'];
    eval(command);
end

warning off;
nummembs = zeros(rows,1)/0;
warning on;
numgroups = 1;

for k=2:rows
    if hhid(k)==1
        nummembs(numgroups) = hhid(k-1);
        numgroups = numgroups+1;
    end
end
nummembs(numgroups) = hhid(rows);
nummembs(numgroups+1:rows) = [];

warning off;

villagenum  =zeros(numgroups,1)/0;
twogrups    =zeros(numgroups,1);

allvars = char(mainvars, occvars);
numvars = nummainvars + numoccvars;
for k=1:numvars
    thisvar = deblank(allvars(k,:));
    command1 = [thisvar 'list   = zeros(numgroups,5)/0;'];
    command2 = [thisvar 'report = zeros(numgroups,1)/0;'];
    eval(command1); eval(command2);
end

warning on;

last = 0;
for j=1:numgroups
    
    frst = last + 1;
    last = last + nummembs(j);

    villagenum(j)   = village(frst);

    if j>1 && villagenum(j)==villagenum(j-1) && villagenum(j)~=492624543, 
            twogrups(j)=1; twogrups(j-1)=1;
    end

    for k=1:numvars
        thisvar = deblank(allvars(k,:));
        command1 = [thisvar 'report(j) = sum(~isnan(' thisvar '(frst:last)));'];
        command2 = [thisvar 'list(j,1:nummembs(j)) = ' thisvar '(frst:last)'';'];
        eval(command1); eval(command2);
    end
end

for k=1:nummainvars
    thisvar      = deblank(mainvars(k,:));
    thisvarshort = deblank(mainvarsshort(k,:));
    command = ['data = ' thisvar 'list; numreports = ' thisvar 'report;'];
    eval(command);
    save(strcat(savedfilepath,thisvarshort,'.mat'), 'villagenum','nummembs','twogrups','numreports','data');
end

warning off;
data = zeros(numgroups,5,numoccvars)/0;
warning on;
for k=1:numoccvars
    thisvar      = deblank(occvars(k,:));
    thisk = num2str(k);
    command = ['data(:,:,' thisk ') = ' thisvar 'list; numreports(:,' thisk ') = ' thisvar 'report;'];
    eval(command);
end
for k=1:numoccvars
    if sum(abs(numreports(:,k)-nummembs))
        error('Missing data in expenditure/revenue lists.');
    end
end
numreports = nummembs;

save(strcat(savedfilepath,'occexprev.mat'), 'villagenum','nummembs','twogrups','numreports','data');