clear all
mindata = 2;

outfile = '..\MultivariateTables2-3\data\probincexp';

load('..\UnivariateFigs1-6\data\resurveyprob.mat');
probtwogrups = twogrups;
probvil = villagenum;
prob = data;

clear data twogrups villagenum;
load('..\UnivariateFigs1-6\data\resurveyinc.mat');
inctwogrups = twogrups;
incvil = villagenum;
inc = data;

clear data twogrups villagenum;
load('..\UnivariateFigs1-6\data\resurveyexp.mat');
exptwogrups = twogrups;
expvil = villagenum;
exp = data;

if sum(abs(probvil-incvil)) || sum(abs(probvil-expvil))
    error('Data not aligned.');
end
if sum(abs(probtwogrups-inctwogrups)) || sum(abs(probtwogrups-exptwogrups))
    error('Data not aligned.');
end
numrecs = length(prob);
if numrecs ~= length(inc) || numrecs ~= length(exp)
    error('Data not aligned.')
end

pair = sum(twogrups)/2;
numg = 2*pair+3;
numv = pair+1;
warning off;
Xprob= zeros(numg,5)/0;
Xinc = zeros(numg,5)/0;
Xexp = zeros(numg,5)/0;
Xspec= zeros(numv,3)/0;
Xvill= zeros(numv,1)/0;
warning on;

%This ensures only individuals are included who have all data
markernew = zeros(numrecs,5);
for j=1:numrecs
for k=1:5
    if ~isnan(prob(j,k)) && ~isnan(inc(j,k)) && ~isnan(exp(j,k)) %&& ~sum(isnan(occ(j,k,:)))
        markernew(j,k)=1;
    end
end
end

%This ensures we include exactly the same as our baseline pwo results, 
%which have three less than pie... by using marker from pwo
load('..\MultivariateTables2-3\data\probwstocc','marker');
diffmarker = markernew-marker;
moredata = sum(sum(diffmarker== 1))
lessdata = sum(sum(diffmarker==-1))


included = zeros(numrecs,1);
j=1;
vill=1;
while j<=numrecs
    if twogrups(j)
        numA = sum(marker(j  ,:));
        numB = sum(marker(j+1,:));
        if min([numA numB]) >= mindata
            Xspec(vill,1) = numA;
            Xspec(vill,2) = numB;
            Xvill(vill) = villagenum(j);
            vill=vill+1;
            included(j:j+1)=1;
        end
        j=j+2;
    else
        j=j+1;
    end
end

j=1;
while j<=numrecs
    if villagenum(j) == 492624543
        numA = sum(marker(j  ,:));
        numB = sum(marker(j+1,:));
        numC = sum(marker(j+2,:));
        if min([numA numB numC]) >= mindata
            Xspec(vill,1) = numA;
            Xspec(vill,2) = numB;
            Xspec(vill,3) = numC;
            Xvill(vill) = villagenum(j);
            vill=vill+1;
            included(j:j+2)=2;
        else error('Look into the three-group village.');
        end
        j=numrecs+1;
    else
        j=j+1;
    end
end

Xspec(vill:numv,:) = [];
Xvill(vill:numv,:) = [];

numincgs = sum(sum(~isnan(Xspec)));

Xprob(numincgs+1:numg,:)= [];
Xinc(numincgs+1:numg,:) = [];
Xexp(numincgs+1:numg,:) = [];

j=1;
g=1;
while j<=numrecs
    if included(j)==1
        ind = find(marker(j,:));
        siz =length(ind);
        Xprob(g,1:siz) = prob(j,ind);
        Xinc(g,1:siz)  = inc(j,ind);
        Xexp(g,1:siz)  = exp(j,ind);
        g=g+1;
    end
    j=j+1;
end

j=1;
while j<=numrecs
    if included(j)==2
        ind = find(marker(j,:));
        siz=length(ind);
        Xprob(g,1:siz) = prob(j,ind);
        Xinc(g,1:siz)  = inc(j,ind);
        Xexp(g,1:siz)  = exp(j,ind);
        g=g+1;
    end
    j=j+1;
end

numvills = vill-1;
[rows cols] = size(Xprob);
entries = rows*cols;

if Xvill(length(Xvill))~=492624543
    error('Not prepared.');
end
warning off;
Yprobtemp       = zeros(numvills,3*cols)/0;
Yinctemp        = zeros(numvills,3*cols)/0;
Yexptemp        = zeros(numvills,3*cols)/0;
warning on;

Yprobtemp(:,1:2*cols)       = (reshape( Xprob(1:(rows-1),:)', 2*cols,numvills))';
Yinctemp(:, 1:2*cols)       = (reshape( Xinc(1:(rows-1), :)', 2*cols,numvills))';
Yexptemp(:, 1:2*cols,:)     = (reshape( Xexp(1:(rows-1), :)', 2*cols,numvills))';
Yprobtemp(numvills,2*cols+1:3*cols) = Xprob(rows,:);
Yinctemp( numvills,2*cols+1:3*cols) = Xinc(rows,:);
Yexptemp( numvills,2*cols+1:3*cols) = Xexp(rows,:);
Yprob    = Yprobtemp;
Yinc     = Yinctemp;
Yexp     = Yexptemp;

[Zspec indices] = sort(Xspec,2);
for j=1:numvills
    Zprob(j,:) = [Yprob(j,(indices(j,1)-1)*5+1:indices(j,1)*5) ...
                  Yprob(j,(indices(j,2)-1)*5+1:indices(j,2)*5) ...
                  Yprob(j,(indices(j,3)-1)*5+1:indices(j,3)*5)];
    Zinc(j,:)  = [Yinc(j,(indices(j,1)-1)*5+1:indices(j,1)*5) ...
                  Yinc(j,(indices(j,2)-1)*5+1:indices(j,2)*5) ...
                  Yinc(j,(indices(j,3)-1)*5+1:indices(j,3)*5)];
    Zexp(j,:)  = [Yexp(j,(indices(j,1)-1)*5+1:indices(j,1)*5) ...
                  Yexp(j,(indices(j,2)-1)*5+1:indices(j,2)*5) ...
                  Yexp(j,(indices(j,3)-1)*5+1:indices(j,3)*5)];
end


save(outfile,'marker','Zspec','Zprob','Zinc','Zexp');