clear all
mindata = 2;

outfile = '..\MultivariateTables2-3\data\probwstocc';

expfarming  = 1;
expshrmpfsh = 2;
expbusiness = 3;
revA = 0;revB = 0;revC = 0;revD = 0;revE = 0;revF = 0;revG = 0;revH = 0;revI = 0;revJ = 0;
revK = 4;revL = 4;
revM = 0;revN = 0;revO = 0;revP = 0;revQ = 0;revR = 0;revS = 0;
revT = 0;revU = 0;revV = 0;revW = 0;revX = 0;revY = 0;revZ = 0;revAA= 0;revBB= 0;
revCC= 0;revDD= 0;revEE= 0;revFF= 0;revGG= 0;revHH= 0;revII= 0;revII1= 0;revII2= 0;revII3= 0;
wts = [1 0.213245; 2 0.181834; 3 0.055033; 4 1];


catgs = [expfarming expshrmpfsh expbusiness revA revB revC revD revE ...
    revF revG revH revI revJ revK revL revM revN revO revP revQ revR ...
    revS revT revU revV revW revX revY revZ revAA revBB revCC revDD ...
    revEE revFF revGG revHH revII revII1 revII2 revII3]';

load('..\UnivariateFigs1-6\data\resurveyprob.mat');
probtwogrups = twogrups;
probvil = villagenum;
prob = data;

clear data twogrups villagenum;
load('..\UnivariateFigs1-6\data\resurveywst.mat');
wsttwogrups = twogrups;
wstvil = villagenum;
wst = data;

clear data twogrups villagenum;
load('..\UnivariateFigs1-6\data\resurveyoccexprev.mat');
occtwogrups = twogrups;
occvil = villagenum;

cd ..\UnivariateFigs1-6; [occ newcatgs] = getoccdata(data,catgs,wts); cd ..\Data;
numcatgs = length(newcatgs);

if sum(abs(probvil-wstvil)) || sum(abs(probvil-occvil))
    error('Data not aligned.');
end
if sum(abs(probtwogrups-wsttwogrups)) || sum(abs(probtwogrups-occtwogrups))
    error('Data not aligned.');
end
numrecs = length(prob);
if numrecs ~= length(wst) || numrecs ~= size(occ,1)
    error('Data not aligned.')
end

pair = sum(twogrups)/2;
numg = 2*pair+3;
numv = pair+1;
warning off;
Xprob= zeros(numg,5)/0;
Xwst = zeros(numg,5)/0;
Xocc = zeros(numg,5,numcatgs)/0;
Xspec= zeros(numv,3)/0;
Xvill= zeros(numv,1)/0;
warning on;

%This ensures only individuals are included who have all data
marker = zeros(numrecs,5);
for j=1:numrecs
for k=1:5
    if ~isnan(prob(j,k)) && ~isnan(wst(j,k)) && ~sum(isnan(occ(j,k,:)))
        marker(j,k)=1;
    end
end
end
included = zeros(numrecs,1);
j=1;
vill=1;
while j<=numrecs
    if twogrups(j)
        numA = sum(marker(j  ,:));
        numB = sum(marker(j+1,:));
        if min([numA numB]) >= mindata
            Xspec(vill,1) = numA;
            Xspec(vill,2) = numB;
            Xvill(vill) = villagenum(j);
            vill=vill+1;
            included(j:j+1)=1;
        end
        j=j+2;
    else
        j=j+1;
    end
end

j=1;
while j<=numrecs
    if villagenum(j) == 492624543
        numA = sum(marker(j  ,:));
        numB = sum(marker(j+1,:));
        numC = sum(marker(j+2,:));
        if min([numA numB numC]) >= mindata
            Xspec(vill,1) = numA;
            Xspec(vill,2) = numB;
            Xspec(vill,3) = numC;
            Xvill(vill) = villagenum(j);
            vill=vill+1;
            included(j:j+2)=2;
        else error('Look into the three-group village.');
        end
        j=numrecs+1;
    else
        j=j+1;
    end
end

Xspec(vill:numv,:) = [];
Xvill(vill:numv,:) = [];

numincgs = sum(sum(~isnan(Xspec)));

Xprob(numincgs+1:numg,:)= [];
Xwst(numincgs+1:numg,:) = [];
Xocc(numincgs+1:numg,:,:)=[];

j=1;
g=1;
while j<=numrecs
    if included(j)==1
        ind = find(marker(j,:));
        siz =length(ind);
        Xprob(g,1:siz) = prob(j,ind);
        Xwst(g,1:siz)  = wst(j,ind);
        Xocc(g,1:siz,:)= occ(j,ind,:);
        g=g+1;
    end
    j=j+1;
end

j=1;
while j<=numrecs
    if included(j)==2
        ind = find(marker(j,:));
        siz=length(ind);
        Xprob(g,1:siz) = prob(j,ind);
        Xwst(g,1:siz)  = wst(j,ind);
        Xocc(g,1:siz,:)= occ(j,ind,:);
        g=g+1;
    end
    j=j+1;
end

numvills = vill-1;
[rows cols] = size(Xprob);
entries = rows*cols;

if Xvill(length(Xvill))~=492624543
    error('Not prepared.');
end
warning off;
Yprobtemp       = zeros(numvills,3*cols)/0;
Ywsttemp        = zeros(numvills,3*cols)/0;
Yocctemp        = zeros(numvills,3*cols,numcatgs)/0;
warning on;

Yprobtemp(:,1:2*cols)       = (reshape( Xprob(1:(rows-1),:)'     , 2*cols,numvills))';
Ywsttemp(:, 1:2*cols)       = (reshape( Xwst(1:(rows-1), :)'     , 2*cols,numvills))';
Yocctemp(:, 1:2*cols,:)     = permute( (reshape( permute(Xocc(1:(rows-1), :,:),[2 1 3])   , 2*cols,numvills,numcatgs)), [2 1 3]);
Yprobtemp(numvills,2*cols+1:3*cols) = Xprob(rows,:);
Ywsttemp( numvills,2*cols+1:3*cols) = Xwst(rows,:);
Yocctemp( numvills,2*cols+1:3*cols,:)= Xocc(rows,:,:);
Yprob    = Yprobtemp;
Ywst     = Ywsttemp;
Yocc     = Yocctemp;

[Zspec indices] = sort(Xspec,2);
for j=1:numvills
    Zprob(j,:) = [Yprob(j,(indices(j,1)-1)*5+1:indices(j,1)*5) ...
                  Yprob(j,(indices(j,2)-1)*5+1:indices(j,2)*5) ...
                  Yprob(j,(indices(j,3)-1)*5+1:indices(j,3)*5)];
    Zwst(j,:)  = [Ywst(j,(indices(j,1)-1)*5+1:indices(j,1)*5) ...
                  Ywst(j,(indices(j,2)-1)*5+1:indices(j,2)*5) ...
                  Ywst(j,(indices(j,3)-1)*5+1:indices(j,3)*5)];
    Zocc(j,:,:)= [Yocc(j,(indices(j,1)-1)*5+1:indices(j,1)*5,:) ...
                  Yocc(j,(indices(j,2)-1)*5+1:indices(j,2)*5,:) ...
                  Yocc(j,(indices(j,3)-1)*5+1:indices(j,3)*5,:)];
end


save(outfile,'marker','Zspec','Zprob','Zwst','Zocc');