clear all

%The orders of the estimates and the subsample files must align!

trueests = [1  0.404;
            1  0.325;
            1 -0.378;
            1 -0.302];

runtypes = char('pw','pw','po','po');

filepw     = 'subsmpl24resultpwall';
filepwbyv  = 'subsmpl24resultpwbyvall';
filepo     = 'subsmpl24resultpoall';
filepobyv  = 'subsmpl24resultpobyvall';
files = char(filepw,filepwbyv,filepo,filepobyv);
nfiles = size(files,1);

samplesize = 32;
capreps = 200;
siglevels = [0.05 0.1 0.15]';
numsiglvls = length(siglevels);

warning off;
pvalueonesidedpos = zeros(nfiles,2)/0;
pvalueonesidedneg = zeros(nfiles,2)/0;
fractposp      = zeros(nfiles,1)/0;
probcoef       = zeros(nfiles,1)/0;
warning on;
results = [];

for k=1:nfiles

    thisfile = deblank(files(k,:));
    
    resultfile = ['results\' thisfile '.mat']
    load(resultfile);
    subsize = unique(sum(mastersampls,2));
    if size(subsize)~=[1 1]
        error('Subsample size off')
    end
    
    [rows cols] = size(masteroutput);
    if rows>capreps
        masteroutput(capreps+1:rows,:)=[];
        rows = capreps;
    end

    numests = length(deblank(runtypes(k,:)))-1;
    warning off;
    finalestimates = zeros(rows,numests+2)/0;
    warning on;
    
    v1ind = 1;
    inds1 = [1:cols/2];
    v2ind = 1+cols/2;
    inds2 = [v2ind:cols];

    for j=1:rows
        if masteroutput(j,v1ind)<masteroutput(j,v2ind)
            finalestimates(j,:) = masteroutput(j,inds1);
        elseif masteroutput(j,v1ind)>masteroutput(j,v2ind)
            finalestimates(j,:) = masteroutput(j,inds2);
        else
            j
            k
            finalestimates(j,:) = masteroutput(j,inds1);
        end
    end

    fractposp(k) = sum(finalestimates(:,2)>0)/rows
    probcoef(k) = trueests(k,1)

    finalestimates(:,1:2) = [];
    theseests = trueests(k,2:numests+1);

    transformdkernels = ((subsize/samplesize)^(1/3)) * (finalestimates-repmat(theseests,rows,1));
    sortedtransformed = sort(transformdkernels);

    for j=1:numests
    thisest = theseests(j);
    thesesubs = sortedtransformed(:,j);
    pvalueonesidedpos(k,j) = 1 - sum(thesesubs < thisest)/rows;
    pvalueonesidedneg(k,j) = 1 - sum(thesesubs > thisest)/rows;
    
    for m=1:numsiglvls
        alpha = siglevels(m);

        thistype = deblank(runtypes(k,:));
        if ~isempty(findstr(files(k,:),'byv'))
            thistype = [thistype 'byv'];
        end
        thistext = [thistype ', Variable ' num2str(j) ' (' num2str(probcoef(k)) ', ' ...
            num2str(thisest) '), Sig ' num2str(alpha) ': '];

        twosided = ['[' num2str(thisest - getcofz(1-alpha/2,thesesubs)) ', ' num2str((thisest - getcofz(alpha/2,thesesubs))) '], '];
        onesidedpos = ['[' num2str(thisest - getcofz(1-alpha,thesesubs)) ', ' num2str(Inf) '), '];
        onesidedneg = ['(' num2str(-Inf) ', ' num2str(thisest - getcofz(alpha,thesesubs)) ']'];
        results = char(results, [thistext twosided onesidedpos onesidedneg]);
    end
    
    end
    
end

pvalueonesidedpos
pvalueonesidedneg
results