clear all;

datafile = 'data\probincexp';

load(datafile);
global prob;
global tinc;
global spec;
global little;
global posneg;
global numvills;
global cmats;
global cmat3;
global cmat3_2gp;
global only2gp;
global indexmat;
global byvil;
global selection;
load('data\combmats');

expinc  = 1;
byvil   = 1;
only2gp = 1;
little  = -10^(-14);
pos     = 1;
neg     = 1;
if expinc
    varstr  = 'pe'
else varstr = 'pi'
end
numberofVariables = length(varstr)-1;
popsize = 300;
initpop = [0];

prob = Zprob;
if expinc
    tinc = Zexp;
else tinc= Zinc;
end
spec = Zspec;
[numvills junk] = size(spec);
selection = ones(numvills,1);

objfun= @gavalpie;

%bounds = [10^(-10) 10^(-8) 10^(-6) 10^(-5) 10^(-4) 10^(-3) 10^(-2) 10^(-1) 1 ...
%    10^(1) 10^(2) 10^(3) 10^(4) 10^(5) 10^(6) 10^(8) 10^(10) ]';
bounds = [20]';
numreps = length(bounds)


for repn = 1:numreps
    thisbound = bounds(repn)
    stepsize = 2*thisbound/(popsize-2);
    initpop = [-thisbound:stepsize:thisbound 0]';
    
posoptions = gaoptimset('PopulationSize',popsize,'Generations',1000,...
    'StallGenLimit',300,'StallTimeLimit',Inf,...
    'MutationFcn',{@mutationuniform,0.15},'EliteCount',20,...
    'CrossoverFraction',0.7,'CrossoverFcn',@crossoverintermediate,...
    'HybridFcn',@patternsearch,'InitialPopulation',initpop);
%posoptions = gaoptimset('InitialPopulation',initpop);
negoptions = gaoptimset(posoptions,'InitialPopulation',initpop);

t0=clock;

randstate = sum(1000*t0);
rand('state',randstate);

if pos
posneg=1;
[betapos, valuepos] = ga(objfun,numberofVariables,[],[],[], ...
    [],[],[],[],posoptions);
betapos
valuepos
end

t1=clock;
timepos = etime(t1,t0)/60

if neg
posneg=-1;
[betaneg, valueneg] = ga(objfun,numberofVariables,[],[],[], ...
    [],[],[],[],negoptions);
betaneg
valueneg
end

t2=clock;
timeneg = etime(t2,t1)/60

timestr = datestr(t0);
timestr(3)=[];
timestr(6:8)=[];
timestr(8)=[];
timestr(10)=[];
timestr(12:14)=[];

if pos & ~neg
    signstr = 'pos';
elseif neg & ~pos
    signstr = 'neg'
else signstr = '';
end
if byvil
    vilstr = 'byv';
else vilstr= '';
end
savedfile = strcat('results\result',...
    varstr,vilstr,signstr,timestr);

if pos & neg
save(savedfile,'valuepos','betapos','timepos','posoptions','thisbound',...
    'little',  'valueneg','betaneg','timeneg','negoptions','randstate','datafile','objfun');
elseif pos
save(savedfile,'valuepos','betapos','timepos','posoptions','thisbound',...
    'little','randstate','datafile','objfun');
elseif neg
save(savedfile,'valueneg','betaneg','timeneg','negoptions','thisbound',...
    'little','randstate','datafile','objfun');
end

end