clear all;

subsize = 24;
reps = 1;

load data\probincexp;
global prob;
global tinc;
global spec;
global little;
global posneg;
global numvills;
global cmats;
global cmat3;
global cmat3_2gp;
global only2gp;
global indexmat;
global byvil;
global selection;
load data\combmats;

expinc  = 0;
byvil   = 1
estimate = 0.594

only2gp = 1;
little  = -10^(-14);
pos     = 1;
neg     = 1;
if expinc
    varstr  = 'pe'
else varstr = 'pi'
end
numberofVariables = length(varstr)-1;
numberofReports = numberofVariables+2;

popsize = 300;
bound = 20;
stepsize = 2*bound/(popsize-3);
initpop = [-bound:stepsize:bound]';
initpop = [initpop; 0; estimate];

prob = Zprob;
if expinc
    tinc = Zexp;
else tinc= Zinc;
end
spec = Zspec;
[numvills junk] = size(spec);

objfun = @gavalpie;

posoptions = gaoptimset('PopulationSize',popsize,'Generations',1000,...
    'StallGenLimit',300,'StallTimeLimit',Inf,...
    'MutationFcn',{@mutationuniform,0.15},'EliteCount',20,...
    'CrossoverFraction',0.7,'CrossoverFcn',@crossoverintermediate,...
    'HybridFcn',@patternsearch,'InitialPopulation',initpop);
negoptions = gaoptimset(posoptions,'InitialPopulation',initpop);

warning off;
output = zeros(reps,2*numberofReports)/0;
time = zeros(reps,2)/0;
samples = zeros(reps,numvills)/0;
randstate = zeros(reps,1)/0;
warning on;

output(:,2)   =  1;
output(:,numberofReports+2) = -1;

for k=1:reps
k
    randstate(k) = sum(1000*clock);
    rand('state',randstate(k));
    [junk randomizer] = sort(rand(numvills,1));
    selection = (randomizer <= subsize);
    samples(k,:) = selection';
    
    t0=clock

    if pos
    posneg=1;
    [output(k,3:numberofReports), output(k,1)] = ga(objfun,numberofVariables,[],[],[], ...
        [],[],[],[],posoptions);
    output(k,1:numberofReports)
    end

    t1=clock;
    time(k,1) = etime(t1,t0)/60

    if neg
    posneg=-1;
    [output(k,numberofReports+3:2*numberofReports) output(k,numberofReports+1)] = ...
        ga(objfun,numberofVariables,[],[],[],[],[],[],[],negoptions);
    output(k,numberofReports+1:2*numberofReports)
    end

    t2=clock;
    time(k,2) = etime(t2,t1)/60

end

timestr = datestr(t2);
timestr = strcat(timestr([1:2 4:6 10:11]),'_',timestr([13:14 16:17 19:20]));

if pos & ~neg
    signstr = 'pos';
elseif neg & ~pos
    signstr = 'neg';
else signstr = '';
end
if byvil
    vilstr = 'byv';
else vilstr= '';
end
savedfile = strcat('results\subsmpl',num2str(subsize),'result',...
    varstr,vilstr,signstr,timestr);

save(savedfile,'output','time','posoptions','negoptions','reps','subsize',...
    'numvills','samples','pos','neg','little','randstate');