function c=geteq3(v, grupnums, stats)
%get the inequality use the column vector
numgroups = length(grupnums);
cumnumgps = cumsum(grupnums);
have2grups = (numgroups==2);
have3grups = (numgroups==3);
if ~have2grups && ~have3grups
    error('Error in geteq3.m');
end

numa = grupnums(1);
numb = grupnums(2);
if have3grups
    numc = grupnums(3);
end
numtotal = sum(grupnums);

warning off;
datatotal = zeros(numtotal,1)/0;
if stats(3)||stats(4)
    databtwn = zeros(numtotal,1)/0;
end
if stats(4)
    means = zeros(numgroups,1)/0;
end
warning on;

if stats(8)||stats(9)||stats(10)||stats(11)
    Nkgsq = zeros(numgroups,1);
    NkgsqdNk = zeros(numgroups,1);
    values = unique(v);
    numvalues = length(values);
    Nk = zeros(numvalues,1);
    for k=1:numvalues
        Nk(k) = sum(v==values(k));
    end
end
if stats(12)||stats(13)||stats(14)
    expabsdifij = zeros(numgroups,1);
end

last = 0;
for g=1:numgroups
    frst = last+1;
    last = cumnumgps(g);
    thisgroup = sort(v(frst:last));
    datatotal(frst:last) = thisgroup;
    if stats(3)||stats(4)
        databtwn(frst:last) = mean(thisgroup);
    end
    if stats(4)
        means(g) = databtwn(last);
    end
    if stats(8)||stats(9)||stats(10)||stats(11)
        for k=1:numvalues
            thisNkgsq = (sum(thisgroup==values(k)))^2;
            Nkgsq(g) = Nkgsq(g) + thisNkgsq;
            NkgsqdNk(g) = NkgsqdNk(g) + thisNkgsq/Nk(k);
        end
    end
    if stats(12)||stats(13)||stats(14)
        thisgrupmat = repmat(thisgroup,1,grupnums(g));
        expabsdifij(g) = sum(sum( exp( -abs(thisgrupmat-thisgrupmat') ) )) - grupnums(g);
    end
end

datagrupa = datatotal(1:numa);
datagrupb = datatotal(numa+1:numa+numb);
if have3grups
    datagrupc = datatotal(numa+numb+1:numtotal);
end

if stats(5)||stats(6)||stats(7)
    pipjgs = [( (sum(datagrupa))^2 - datagrupa'*datagrupa) ; ...
              ( (sum(datagrupb))^2 - datagrupb'*datagrupb)];
    if have3grups
        pipjgs = [pipjgs; ( (sum(datagrupc))^2 - datagrupc'*datagrupc)];
    end
end

c = [];

if stats(1)
    if have2grups
        Kendall  = ktau(datatotal,numa);
    else Kendall = ktau3(datatotal,numa,numb);
    end
    c = [c; Kendall]; 
end
if stats(2)
    if have2grups
        Spearman = srho(datatotal,numa);
    else Spearman = srho3(datatotal,numa,numb);
    end
    c = [c; Spearman];
end
if stats(3)
    sdatatotal = sort(datatotal);
    sdatabtwn  = sort(databtwn );
    Varbtwpct  = var(sdatabtwn,1)/var(sdatatotal,1);
    c = [c; Varbtwpct];
end
if stats(4)
    if have2grups
        Meandif = abs(means(1)-means(2));
    else Meandif = ((numa+numb)/(2*numtotal))*abs(means(1)-means(2)) + ...
        ((numa+numc)/(2*numtotal))*abs(means(1)-means(3)) + ...
        ((numb+numc)/(2*numtotal))*abs(means(2)-means(3));
    end
    c = [c; Meandif];
end
if stats(5)
    c = [c; sum( pipjgs )];
end
if stats(6)
    % This gives the sum (equivalent to average, given fixed total number
    % of borrowers) across individuals of own pi times average pj of fellow
    % group members (not including self).
    c = [c; sum( pipjgs./(grupnums-1) )];
end
if stats(7)
    % This gives the group-stratified average across individuals of own pi 
    % times average pj of fellow group members (not including self). 
    c = [c; sum( pipjgs./(grupnums.*(grupnums-1)) )];
end
if stats(8)
%{
The percent of fractionalization attributable to the between component 
depends only on the following, as can be shown, for fixed group sizes and 
total population.  
Also, directly interpretable as total within-group links (including OR 
excluding self-links, it only depends on this for fixed group sizes) with 
the same value, or fraction of within-group links with the same value
(again, given fixed group sizes).
%}    
    c = [c; sum( Nkgsq )];
end
if stats(9)
%{
This is analogous to picking a guy at random and asking what fraction of
his group is the same, excluding himself (if including himself, do not
subtract 1). Thus it is the average fraction of within-group links 
(excluding own-links) that have the same value, across all individuals in
the village.
%}
    c = [c; sum( Nkgsq./(grupnums-1) )];
end
if stats(10)
%{
This is analogous to picking a group at random, then a guy at random, then
asking what fraction of his group is the same, excluding himself (if 
including himself, do not subtract 1). Thus it is the group-average of the
individual-average fraction of within-group links (excluding own-links) 
that have the same value, across all individuals in the group.
%}
    c = [c; sum( Nkgsq./(grupnums.*(grupnums-1)) )];
end
if stats(11)
% This is for the chi-sq test statistic.
    c = [c; sum( NkgsqdNk./grupnums )];
end
if stats(12)
    c = [c; sum( expabsdifij )];
end
if stats(13)
    c = [c; sum( expabsdifij./(grupnums-1) )];
end
if stats(14)
    c = [c; sum( expabsdifij./(grupnums.*(grupnums-1)) )];
end
if stats(15)
    if have2grups
        Pcovar = pcov(datatotal,numa);
    else Pcovar = pcov3(datatotal,numa,numb);
    end
    c = [c; Pcovar]; 
end