function [posdata poscatgs] = getoccdata(data,catgs,wts)

%This deletes all data and category settings where category=0
indiceszero = find(catgs==0);
catgs(indiceszero)=[];
data(:,:,indiceszero)=[];

%This collapses data into the unique categories
[rows cols junk] = size(data);
unqcatgs = unique(catgs);
numcatgs = length(unqcatgs);
newdata = zeros(rows,cols,numcatgs);

for j=1:numcatgs
    thiscatg = unqcatgs(j);
    indices = find(catgs==thiscatg);
    newdata(:,:,j) = sum(data(:,:,indices),3);
end

%This weights data if specified (i.e. if wts~=0)
if sum(sum(abs(wts)))
'Weighting data'
    for j=1:numcatgs
        thiscatg = unqcatgs(j);
        wtindex = find(wts(:,1)==thiscatg);
        thiswt = wts(wtindex,2);
        newdata(:,:,j) = thiswt*newdata(:,:,j);
    end
end

%This changes to fractions; NaN if no positive entry in any category
for i=1:rows
for j=1:cols
    warning off;
    newdata(i,j,:) = newdata(i,j,:)/sum(newdata(i,j,:));
    warning on;
end
end

%This gets rid of negative categories, which only count in the denominator
%and have already been used there
poscatgindices = find(unqcatgs>0);
poscatgs = unqcatgs(poscatgindices);
posdata = newdata(:,:,poscatgindices);