clear all

varshort = 'reocc';
varname  = 'Occupation via Revenue';

datafile = 'data\resurveyoccexprev.mat';
resultfile = strcat('results\result',varshort,'plus.mat');%Plus

permprog = 'permutecatineqplus';%Plus
numdata = 10;%Plus
equalerr = 10^(-14);

% Stats to include. 
frcdcmp = 0;
avgmansam = 0;
avggrpsam = 0;
chisq = 1;
taxicab = 1;

% For multiplicatively weighting categories; if left at default zeroes value, no weights
% If weights are set, they are a two-column matrix with category in the
% first column and corresponding weight in the second column
%{ 
FOR CATEGORIES, 0 means to exclude from denominator and numerator, and any negative number
means to exclude from numerator but not denominator. 
Strictly positive numbers are used to delineate all distinct occupational categories
for revenue, i.e. all "1"s are the same occupation, all "2"s are the same occupation, etc.
%}


testno = 'W3c';
expfarming  = 1;
expshrmpfsh = 2;
expbusiness = 3;
revA = 0;revB = 0;revC = 0;revD = 0;revE = 0;revF = 0;revG = 0;revH = 0;revI = 0;revJ = 0;
revK = 4;revL = 4;
revM = 0;revN = 0;revO = 0;revP = 0;revQ = 0;revR = 0;revS = 0;
revT = 0;revU = 0;revV = 0;revW = 0;revX = 0;revY = 0;revZ = 0;revAA= 0;revBB= 0;
revCC= 0;revDD= 0;revEE= 0;revFF= 0;revGG= 0;revHH= 0;revII= 0;revII1= 0;revII2= 0;revII3= 0;
wts = [1 0.213245; 2 0.181834; 3 0.055033; 4 1];



parmstrings = char(datafile,permprog,varname);
stats = [0 0 0 0 0 0 0 frcdcmp avgmansam avggrpsam chisq 0 0 0 taxicab]';
catgs = [expfarming expshrmpfsh expbusiness revA revB revC revD revE ...
    revF revG revH revI revJ revK revL revM revN revO revP revQ revR ...
    revS revT revU revV revW revX revY revZ revAA revBB revCC revDD ...
    revEE revFF revGG revHH revII revII1 revII2 revII3]';

output = runocc(parmstrings,stats,numdata,equalerr,catgs,wts);

save(resultfile,'parmstrings','stats','numdata','equalerr','output','catgs','wts');